"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const os = __importStar(require("os"));
const path = __importStar(require("path"));
const io = __importStar(require("@actions/io"));
function configAuthentication(username, password) {
    return __awaiter(this, void 0, void 0, function* () {
        const directory = path.join(os.homedir(), '.m2');
        yield io.mkdirP(directory);
        yield write(directory, generate(username, password));
    });
}
exports.configAuthentication = configAuthentication;
// only exported for testing purposes
function generate(username = '${actions.username}', password = '${actions.password}') {
    return `<settings>
                <servers>
                <server>
                    <username>${username}</username>
                    <password>${password}</password>
                </server>
                </servers>
            </settings>
    `;
}
exports.generate = generate;
function write(directory, settings) {
    return __awaiter(this, void 0, void 0, function* () {
        return fs.writeFileSync(path.join(directory, 'settings.xml'), settings);
    });
}
